<?php
/**
 * The template for displaying a single event
 *
 ***************** NOTICE: *****************
 *  Do not make changes to this file. Any changes made to this file
 * will be overwritten if the plug-in is updated.
 *
 * To overwrite this template with your own, make a copy of it (with the same name)
 * in your theme directory. 
 *
 * WordPress will automatically prioritise the template in your theme directory.
 ***************** NOTICE: *****************
 *
 * @package Event Organiser (plug-in)
 * @since 1.0.0
 */

//Call the template header

get_header(); 

// different time formats used 
$day_format = 'l F d, Y';
$day_short  =  'l F d';
$time_format = 'g:iA';
$timestamp = 'l F d, Y g:iA';

?>
	
	<div class="hfeed content">
	
	<?php hybrid_before_content(); // Before content hook ?>
	
	<?php if ( have_posts() ) : while ( have_posts() ) : the_post(); ?>

			
			<div id="post-<?php the_ID(); ?>" class="<?php hybrid_entry_class(); ?>">
			

			<div class="entry-header">
				
				<!---- Display event title-->
				<h1 class="entry-title event-title"><?php the_title(); ?></h1>
				
				<div class="entry-meta">
					<p>
					<?php if( eo_reoccurs() ): ?>
						
						<?php $next = eo_get_next_occurrence( $timestamp ); ?>
						<?php if( $next ): ?>
						
							<?php echo "Next: ". $next; ?>
					
						<?php else: ?>
							<!---- Otherwise the event has finished (no more occurrences) -->
							<?php printf(__('This event finished on %s','eventorganiser'), eo_get_schedule_end( $date_format ));?> 
						<?php endif; ?>
						<br /><em><?php echo	eo_get_schedule_summary(); ?></em>
					<?php else: 
						if( !eo_is_allday() ): 
							$start_date = eo_get_the_start('l F d, Y');
							$end_date = eo_get_the_end('l F d, Y');
							if($start_date == $end_date)
								echo eo_get_the_start('l F d, Y g:iA'). " - ". eo_get_the_end('g:iA');
							else
								echo eo_get_the_start('l F d, Y g:iA'). " - ".eo_get_the_end('l F d, Y g:iA');
							?>
						<?php else: 
							
							$start_date = eo_get_the_start('l F d, Y');
							$end_date = eo_get_the_end('l F d, Y');
							if($start_date == $end_date)
								echo $start_date;
							else
								echo $start_date. " - ".$end_date;
							?>
							- This is an all day event
						<?php endif; ?> <!-- end eo_is_allday -->
						
					<?php endif; ?>
					<br />
					
					<?php
				//Events have their own 'event-category' taxonomy. Get list of categories this event is in.
				$categories_list = get_the_term_list( get_the_ID(), 'event-category', '', ', ',''); 

				if ( '' != $categories_list ) {
					$utility_text = __( 'This event was posted in %1$s', 'eventorganiser' );
					printf( $utility_text, $categories_list );
					
				} else {
					$utility_text = __( 'This event was posted by <a href="%5$s">%4$s</a>.', 'eventorganiser' );
				} 
				
				?>
				</div><!-- .entry-meta -->
				
			</div><!-- .entry-header -->
	
			<div class="entry-content entry">
				<!---- The content or the description of the event-->
				<?php the_content(); ?>
				<?php wp_link_pages( array( 'before' => '<div class="page-link"><span>' . __( 'Pages:', 'eventorganiser' ) . '</span>', 'after' => '</div>' ) ); ?>
						
				<?php 

				// Show the Venue information
				$venue_id = (int) eo_get_venue($post_id); 

				if( $venue_id ):
					$venue_name = eo_get_venue_name($post_id);
					$address_details = eo_get_venue_address($venue_id);

					// eo_get_venu_address contains the keys: address, postcode, and country
						echo '<div id="meta-location">';
						echo '<div id="location-title">Location:</div>';
						echo "<a class='location-venue' href='".eo_get_venue_link()."'>".$venue_name."</a><br />";
						
						
						echo '<div class="adr">';
						if(! empty( $address_details['address'] ) )
							echo '<span class="street-address">'.$address_details['address'].' </span><br />';
						
						if(! empty( $address_details['postcode'] ) )
							echo '<span class="postal-code">'.$address_details['postcode']." </span><br />";
						
						if(! empty( $address_details['country'] ) )
							echo '<span class="country-name">'.$address_details['country']. '</span><br />';
							
						echo "</div>";
	
						if ($venue_name) {
						// if (($venue_name = eo_get_venue_name())) {
							
	       						echo do_shortcode('[eo_venue_map]');
	          				}
	
							
					echo '</div>';
				endif;
				// Get the link to subscribe through iCal - Not working
						// echo "<br><br>Subscribe: ";
						// echo do_shortcode('[eo_subscribe]');
						// echo "<br><br>";


				?>
				</div><!-- .entry-content -->
				<div  class="entry-meta">

				
				<?php edit_post_link( __( 'Edit'), '<span class="edit-link">', '</span>' ); ?>
				</div><!-- .entry-meta -->
					
					
		</div><!-- #post-<?php the_ID(); ?> -->
				
		<?php hybrid_after_page(); // After page hook ?>
	
		<?php endwhile; // end of the loop. ?>

		<?php else: ?>

			<p class="no-data">
				<?php _e('Sorry, no page matched your criteria.', 'hybrid'); ?>
			</p><!-- .no-data -->

		<?php endif; ?>

		<?php hybrid_after_content(); // After content hook ?>

	</div><!-- .content .hfeed -->
<?php get_footer(); ?>

