<?php
/**
 * Home Template
 * Template Name: Frontpage
 * 
 * This template is loaded when on the home/blog page.
 * 
 * @package Hybrid
 * @subpackage Template
 */
 
// get_page_template();

if(!$clf_base_options)
	$clf_base_options = get_option("clf_base");

// the user selected the option 1 to 3 
if( isset($clf_base_options['frontpage']['option']) && $clf_base_options['frontpage']['option']>=1 && is_front_page() ):
	
	get_header(); ?>
	<div id="content" class="hfeed content">
		<?php hybrid_before_content(); // Before content hook
		
		// frontpage options  
		if( is_page() ): // the page is accually a page - display the contents of the page minus the page title 
			if ( have_posts() ) : while ( have_posts() ) : the_post(); ?>
				<div id="post-<?php the_ID(); ?>" >
					<div class="entry-content entry">
						<?php the_content(); ?>
						<?php wp_link_pages( array( 'before' => '<p class="pages">' . __('Pages:', 'hybrid'), 'after' => '</p>' ) ); ?>
					</div><!-- .entry-content -->
				</div><!-- .hentry .post -->
				<?php endwhile; ?>

			<?php else: ?>

				<p class="no-data">
					<?php _e('Sorry, no page matched your criteria.', 'hybrid'); ?>
				</p><!-- .no-data -->
	
			<?php endif; 
		endif;
			?>
			<div class="dynamic-content">
				<?php echo clf_base_spotlight(array('frontpage_option'=>$clf_base_options['frontpage']['option'])); ?>
			</div>
			<?php if ( is_sidebar_active( 'frontpage-widget' ) ) : ?>

			<div id="frontpage-widget" class="frontpage-widget aside">

				<?php dynamic_sidebar( 'frontpage-widget' ); ?>

			</div><!-- .frontpage-widget .aside -->

			<?php endif; 
			$column_number = sizeof($clf_base_options['frontpage']['content_area']);
			?>
			<div class="static-content static-coumns-<?php echo $column_number; ?>">
			<?php 
			$column_counter = 0;
			foreach($clf_base_options['frontpage']['content_area'] as $column_content): $column_counter++; ?>
				<div class="column <?php echo ($column_counter == $column_number ? "last":"");?>">
				<?php echo do_shortcode($column_content); ?>
				</div>
			<?php endforeach;
			hybrid_after_content(); // After content hook  ?>
			</div>
			<?php hybrid_after_content(); // After content hook ?>

	</div><!-- .content .hfeed -->

	<?php get_footer(); 
		
else: // the user seelcted the default option 
if(get_page_template()):
	include(get_page_template());
else:
get_header(); ?>
	<div class="hfeed content">
		<?php hybrid_before_content(); // Before content hook
if ( have_posts() ) : while ( have_posts() ) : the_post(); ?>
			
			<div id="post-<?php the_ID(); ?>" class="<?php hybrid_entry_class(); ?>">

				<?php hybrid_before_entry(); // Before entry hook ?>

				<div class="entry-content entry">
					<?php the_content( sprintf( __('Continue reading %1$s', 'hybrid'), the_title( ' "', '"', false ) ) ); ?>
					<?php wp_link_pages( array( 'before' => '<p class="pages">' . __('Pages:', 'hybrid'), 'after' => '</p>' ) ); ?>
				</div><!-- .entry-content -->

				<?php hybrid_after_entry(); // After entry hook ?>

			</div><!-- .hentry .post -->

			<?php endwhile; ?>

		<?php else: ?>

			<p class="no-data">
				<?php _e('Sorry, no posts matched your criteria.', 'hybrid'); ?>
			</p><!-- .no-data -->

		<?php endif; ?>
		<?php hybrid_after_content(); // After content hook ?>

	</div><!-- .content .hfeed -->

	<?php get_footer(); 
endif;
endif; 