<?php 
include "lib/GIFEncoder.class.php";

function get_dip($font,$size)
{
	$test_chars = 'abcdefghijklmnopqrstuvwxyz' .
			      'ABCDEFGHIJKLMNOPQRSTUVWXYZ' .
				  '1234567890' .
				  '!@#$%^&*()\'"\\/;.,`~<>[]{}-+_-=' ;
	$box = @ImageTTFBBox($size,0,$font,$test_chars) ;
	return $box[3];
}

function hex_to_rgb($hex)
{
    // remove '#'
    if(substr($hex,0,1) == '#')
        $hex = substr($hex,1) ;

    // expand short form ('fff') color
    if(strlen($hex) == 3)
    {
        $hex = substr($hex,0,1) . substr($hex,0,1) .
               substr($hex,1,1) . substr($hex,1,1) .
               substr($hex,2,1) . substr($hex,2,1) ;
    }

    if(strlen($hex) != 6) {
        return 'Error: Invalid color "'.$hex.'"';
	}
	
    // convert
    $rgb['red'] = hexdec(substr($hex,0,2)) ;
    $rgb['green'] = hexdec(substr($hex,2,2)) ;
    $rgb['blue'] = hexdec(substr($hex,4,2)) ;

    return $rgb ;
}
/*
function javascript_to_html($text)
{
    $matches = null ;
    preg_match_all('/%u([0-9A-F]{4})/i',$text,$matches) ;
    if(!empty($matches)) for($i=0;$i<sizeof($matches[0]);$i++)
        $text = str_replace($matches[0][$i],
                            '&#'.hexdec($matches[1][$i]).';',$text) ;

    return $text ;
}

if(! function_exists('str_split'))
{
	function str_split($text, $split = 1)
	{
		$array = array();
	   
		for ($i = 0; $i < strlen($text); $i += $split)
		{
			$array[] = substr($text, $i, $split);
		}
	   
		return $array;
	}
}

function validateHexColor($color) {
    $color = substr($color, 0, 6);
    return preg_match('/[0-9a-fA-F]{6}/', $color);
}
*/
function clf_generate_header($settings) {
	
	$facultyname = $settings['clf_header_umbrella_name'];
	$unitname = $settings['clf_header_unit_name'];
	$color = $settings['clf_header_colour_option'];
	$pomcolor = $settings['clf_header_pom_colour'];
	if($settings['clf_header_umbrella_name'] == 'The University of British Columbia') {
		$unittype = 'faculty';
	} else {
		$unittype = 'academic';
	}

	// Paths
	$wud = wp_upload_dir();
	$url_path = $wud['baseurl']."/clf_base";
	$cache_path = $wud['basedir']."/clf_base/";
	$options_path = "/library/clf-header/imgs/";
	
	if(!file_exists($cache_path)) {
		$parent = $wud['basedir'];
		if(!file_exists($parent)) {
			mkdir($parent); 
		}
		mkdir($cache_path); 
	}
	
	$header_paths = array(
		# Defaults
		'ubcLogo' => get_bloginfo('stylesheet_directory').$options_path."ubcLogo1.gif",
		'ubcHeader' => get_bloginfo('stylesheet_directory').$options_path."ubcHeader1.gif",
		'ubcSubUnit' => get_bloginfo('stylesheet_directory').$options_path."ubcSubUnit1.gif",
		'placeOfMind' => get_bloginfo('stylesheet_directory').$options_path."placeOfMind1.gif",
		'PlaceOfMind-Gif-V04-off' => get_bloginfo('stylesheet_directory').$options_path."PlaceOfMind-Gif-V04-off1.gif",
		'PlaceOfMind-Gif-V04-on' => get_bloginfo('stylesheet_directory').$options_path."PlaceOfMind-Gif-V04-on1.gif",
		'PlaceOfMind-Gif-V04-unanimated' => get_bloginfo('stylesheet_directory').$options_path."PlaceOfMind-Gif-V04-unanimated1.gif"
	);
	
	# Actual image generation code
	$success = clf_generate_ubcSubUnit($unitname, $unittype, $color, $cache_path);
	
	if($facultyname != "The University of British Columbia") {
		$success = ($success && clf_generate_ubcHeader($facultyname, $unittype, $color, $cache_path));
	}
	
	if($color>4) {
		$success = ($success && clf_generate_pom($pomcolor, $cache_path));	
	}
	
	if($success) {
		if($color>1) {
		
			$header_paths['ubcLogo'] = get_bloginfo('stylesheet_directory').$options_path."ubcLogo".$color.".gif";
			
			if($settings['clf_header_colour_option']<=4) { // POM Images
				// Use Defaults
				$header_paths['placeOfMind'] = get_bloginfo('stylesheet_directory').$options_path."placeOfMind".ceil($color/2).".gif";
				$header_paths['PlaceOfMind-Gif-V04-off'] = get_bloginfo('stylesheet_directory').$options_path."PlaceOfMind-Gif-V04-off".ceil($color/2).".gif";
				$header_paths['PlaceOfMind-Gif-V04-on'] = get_bloginfo('stylesheet_directory').$options_path."PlaceOfMind-Gif-V04-on".ceil($color/2).".gif";
				$header_paths['PlaceOfMind-Gif-V04-unanimated'] = get_bloginfo('stylesheet_directory').$options_path."PlaceOfMind-Gif-V04-unanimated".ceil($color/2).".gif";
			} else {			
				// Use generated images
				$header_paths['placeOfMind'] = $url_path."/placeOfMind.gif";
				$header_paths['PlaceOfMind-Gif-V04-off'] = $url_path."/PlaceOfMind-Gif-V04-off.gif";
				$header_paths['PlaceOfMind-Gif-V04-on'] = $url_path."/PlaceOfMind-Gif-V04-on.gif";
				$header_paths['PlaceOfMind-Gif-V04-unanimated'] = $url_path."/PlaceOfMind-Gif-V04-unanimated.gif";
			} // End POM Images
			
		}
		
		// Use generated text headers
		if($facultyname != "The University of British Columbia") {
			$header_paths['ubcHeader'] = $url_path."/ubcHeader.gif";
		} else {
			if($color >= 5) { $headercolor = $color-2; } else { $headercolor = $color; }
			$header_paths['ubcHeader'] = get_bloginfo('stylesheet_directory').$options_path."/ubcHeader".$headercolor.".gif";
		}
		
		$header_paths['ubcSubUnit'] = $url_path."/ubcSubUnit.gif";

	}
	
	return $header_paths;
}

$ubc_blue = '#002859';
$ubc_grey = '#7491a3';
$white = '#ffffff';

$clf_color_options = array(
	'1' => array(
		'font' => $white,
		'background' => $ubc_blue,
		'pom' => $ubc_blue,
	),
	'2' => array(
		'font' => $ubc_blue,
		'background' => $white,
		'pom' => $ubc_blue,
	),
	'3' => array(
		'font' => $white,
		'background' => $ubc_grey,
		'pom' => $ubc_grey,
	),
	'4' => array(
		'font' => $ubc_grey,
		'background' => $white,
		'pom' => $ubc_grey,
	),
	'5' => array(
		'font' => $white,
		'background' => $ubc_grey,
		'pom' => $custom_color,
	),
	'6' => array(
		'font' => $ubc_grey,
		'background' => $white,
		'pom' => $custom_color,
	),
);

$font_file = STYLESHEETPATH."/library/clf-header/generator/wb.ttf";


function clf_generate_ubcHeader($facultyname, $unittype, $color, $cache_path) {
	global $clf_color_options, $font_file;

	// Basic Image Parameters
	$facultywidth = 379;
	$facultyheight = 98;
	$facultybaseline = 32;
	$facultytracking = 3;
	$facultyleading = 16;
	$facultyleft = 25;
	$facultyfontsize = 7.5;



	// Create Image and Allocate Colours
	$facultyimage = ImageCreate($facultywidth,$facultyheight);
	if(!$facultyimage) { return false; }
	
	$background_rgb = hex_to_rgb($clf_color_options[$color]['background']);
	$font_rgb = hex_to_rgb($clf_color_options[$color]['font']);
	
	$background_color = @ImageColorAllocate($facultyimage,$background_rgb['red'],
		$background_rgb['green'],$background_rgb['blue']);
	$font_color = ImageColorAllocate($facultyimage,$font_rgb['red'],
		$font_rgb['green'],$font_rgb['blue']);
	
	$array = str_split(strtoupper($facultyname));
	$hpos = $facultyleft;
	
	for($i=0; $i<count($array); $i++)
	{
		if(ord($array[$i]) != 10) {
			$bbox = imagettftext($facultyimage, $facultyfontsize, 0, $hpos, $facultybaseline, $font_color, $font_file, $array[$i]);
			$hpos = $bbox[2]+$facultytracking;
		} else {
			$hpos = $facultyleft;
			$facultybaseline += $facultyleading;
		}
	}
	// set transparency
	if($transparent_background) {
		ImageColorTransparent($facultyimage,$background_color) ;
	}
	
	$faculty_cached = $cache_path.'ubcHeader.gif';;
	$success = ImageGIF($facultyimage,$faculty_cached);
	ImageDestroy($facultyimage);
	
	return $success;
}

function clf_generate_ubcSubUnit($unitname, $unittype, $color, $cache_path) {
	
	// Basic Image Parameters
	$unitwidth = 314;
	$unitheight = 98;
	$unitbaseline = 32;
	$unittracking = 4;
	if($unittype=='academic') {
		$unittracking = 1;	
	} else {
		$unitname = strtoupper($unitname);
	}
	$unitleading = 19;
	$unitleft = 28;
	$unitfontsize = 10;
	
	global $clf_color_options;
	global $font_file; 
	// Create Image and Allocate Colours
	$unitimage = ImageCreate($unitwidth,$unitheight);
	if(!$unitimage) { return false; }
	
	$background_rgb = hex_to_rgb($clf_color_options[$color]['background']);
	$font_rgb = hex_to_rgb($clf_color_options[$color]['font']);
	
	$background_color = @ImageColorAllocate($unitimage,$background_rgb['red'],
		$background_rgb['green'],$background_rgb['blue']);
	$font_color = ImageColorAllocate($unitimage,$font_rgb['red'],
		$font_rgb['green'],$font_rgb['blue']);
	
	//draw unit text
	$array = str_split($unitname);
	$hpos = $unitleft;
	
	for($i=0; $i<count($array); $i++)
	{
		if(ord($array[$i]) != 10) {
			$bbox = imagettftext($unitimage, $unitfontsize, 0, $hpos, $unitbaseline, $font_color, $font_file, $array[$i]);
			$hpos = $bbox[2]+$unittracking;
			#$hpos = $bbox[2];
		} else {
			$hpos = $unitleft;
			$unitbaseline += $unitleading;
		}
	}
	
	$unit_cached = $cache_path.'ubcSubUnit.gif';
	$success = ImageGIF($unitimage,$unit_cached);
	ImageDestroy($unitimage);
	
	return $success;
}
function clf_generate_pom($pomcolor, $cache_path) {
	$lib = STYLESHEETPATH."/library/clf-header/generator/lib/";
	
	$colorbg = imagecreate('188','196');
	$pom_rgb = hex_to_rgb($pomcolor);
	$background_color = @ImageColorAllocate($colorbg,$pom_rgb['red'],
		$pom_rgb['green'],$pom_rgb['blue']);
	imagejpeg($colorbg, $cache_path.'colored1.jpg');
	ImageDestroy($colorbg);
	
	// Double Sprite
	$imgsrc = imagecreatefromjpeg($cache_path.'colored1.jpg');
	$stamp = imagecreatefrompng($lib.'sprite_watermark.png');
	
	imagecopy($imgsrc, $stamp, 0, 0, 0, 0, 188, 196);
	
	$placeofmind_pngcached = $cache_path.'pom_image.png';
	imagepng($imgsrc,$placeofmind_pngcached);
	$gifsrc = imagecreatefrompng($placeofmind_pngcached);
	imagepalettecopy( $gifsrc, $imgsrc);
	
	$placeofmind_gifcached = $cache_path.'placeOfMind.gif';
	imagegif($gifsrc,$placeofmind_gifcached);
	
	ImageDestroy($imgsrc);
	ImageDestroy($stamp);
	
	
	// Animated Version
	$colorbg = imagecreate('187','98');
	$pom_rgb = hex_to_rgb($pomcolor);
	$background_color = @ImageColorAllocate($colorbg,$pom_rgb['red'],
		$pom_rgb['green'],$pom_rgb['blue']);
	imagejpeg($colorbg, $cache_path.'animatecolor1.jpg');
	ImageDestroy($colorbg);
	
	$frames = array();
	for($f=0; $f<11; $f++) {
		$frame_img = imagecreatefromjpeg($cache_path.'animatecolor1.jpg');
		$overlay = $f+1;
		$frame_overlay = imagecreatefrompng($lib.'/wm_frame'.$overlay.'.png');
		imagecopy($frame_img, $frame_overlay, 0, 0, 0, 0, 187, 98);
		$animated_gifcached = $cache_path.'animated_pom'.$f.'.gif';
		imagegif($frame_img,$animated_gifcached);
		$frames[$f] = $animated_gifcached;
		ImageDestroy($frame_img);
		ImageDestroy($frame_overlay);
	}
	
	$framed = array();
	array_fill(0, 9, 20);
	$framed[10] = 210;
	
	$gif = new GIFEncoder	($frames,$framed,
		0,
		2,
		0, 0, 0,
		"url"
	);
	
	$animated_org = $cache_path.'/PlaceOfMind-Gif-V04-on.gif';
	FWrite ( FOpen ($animated_org, "wb" ), $gif->GetAnimation ( ) );
	$file = $cache_path.'PlaceOfMind-Gif-V04-off.gif';
	if (!copy($animated_org, $file)) {
		return false;
	}
	
	// Unanimated Version
	$unanimated_img = imagecreatefromjpeg($cache_path.'animatecolor1.jpg');
	$unanimated_overlay = imagecreatefrompng($lib.'/nonanimated_watermark.png');
	
	imagecopy($unanimated_img, $unanimated_overlay, 0, 0, 0, 0, 187, 98);
	
	$unanmiated_cache = $cache_path.'PlaceOfMind-Gif-V04-unanimated.gif';
	imagegif($unanimated_img,$unanmiated_cache);
	
	ImageDestroy($unanimated_img);
	ImageDestroy($unanimated_overlay);

	return true;	
}
