<?php 
/** 
 * CLF Header
 * 
 *
 */
 
// include('generator/clf-graphic-generator.php' );
include("generator/generator.php");

add_action('admin_init', 'clf_base_clf_header');


add_filter("clf_base_theme_options_validate", "clf_base_clf_header_generate");

add_filter("clf_base_modify_style_css_content",'clf_base_modify_clf_header_css');	

function clf_base_clf_header()
{
	add_settings_field('clf-header', 'UBC Header', 'clf_base_theme_options_clf_header', 'clf-base-theme-options', 'clf');
	
	add_settings_field('clf_base_clf_header_color', 'Header Colour Options', 'clf_base_theme_options_clf_header_colors', 'clf-base-theme-options', 'clf');
	add_settings_field('clf_base_clf_header_faculty', 'Header Faculty Label', 'clf_base_theme_options_clf_header_faculty', 'clf-base-theme-options', 'clf');
	add_settings_field('clf_base_clf_header_unit', 'Header Unit Label', 'clf_base_theme_options_clf_header_unit', 'clf-base-theme-options', 'clf');
	
	
	add_action('clf_base_admin_ui','clf_base_clf_header_styles');
	// Styles for the UBC Header Panel
	wp_register_style('clf-base-css-ui-ubc-header', get_bloginfo('stylesheet_directory').'/library/clf-header/panel.css');
		
	// Check for server-side CLF generator code.  IF exists, enable additional functionality.
	
}

function clf_base_clf_header_styles()
{
	wp_enqueue_style( 'clf-base-css-ui-ubc-header');
	wp_enqueue_script('clf-base-clf-header-panel', get_bloginfo('stylesheet_directory').'/library/clf-header/panel.js', array('jquery'));
}

function clf_base_modify_clf_header_css($css)
{
	global $clf_base_options;
	
	
	$clf_header = new ClfBaseCLFGenerator($clf_base_options['clf_header']);
	
	$css = str_replace("/wp-content/themes/clf-base/library/clf/img/header/ubcLogo.gif", $clf_header->display_ubclogo_image(), $css);
	$css = str_replace("/wp-content/themes/clf-base/library/clf/img/header/ubcHeader.gif", $clf_header->display_header_image(), $css);
	$css = str_replace("/wp-content/themes/clf-base/library/clf/img/header/ubcSubUnit.gif", $clf_header->display_unit_image(), $css);
	$css = str_replace("/wp-content/themes/clf-base/library/clf/img/header/placeOfMind.gif", $clf_header->display_pom_image(), $css);
	$css = str_replace("/wp-content/themes/clf-base/library/clf/img/header/PlaceOfMind-Gif-V04-unanimated.gif",$clf_header->display_pom_unanimated_image(),$css);
	$css = str_replace("/wp-content/themes/clf-base/library/clf/img/header/PlaceOfMind-Gif-V04-on.gif",$clf_header->display_pom_on_image(),$css);
	$css = str_replace("/wp-content/themes/clf-base/library/clf/img/header/PlaceOfMind-Gif-V04-off.gif",$clf_header->display_pom_off_image(),$css);
	
	$css = str_replace("url(/wp-content/themes/clf-base", "url(".get_stylesheet_directory_uri(), $css);
	/* make sure that the clicker is minimized when the page loads but the images haven't loaded yet */
	switch($clf_base_options['clf_header']['option']){
		case 1:
			$css .= "#UbcHeader{ background-color: #002859;}";
		break;
		case 3:
		case 5:
			$css .= "#UbcHeader{ background-color: #7491A3;}";
		break;
		case 2:
		case 4:
		case 6:
			$css .= "#UbcHeader{ background-color: #FFF;}";
		break;
		default:
			$css .= "#UbcHeader{ background-color: #002859}";
		break;
	}
	
	
	return $css;
}

function clf_base_theme_options_clf_header()
{
	
	global $clf_base_options;
	
	$clf_header = new ClfBaseCLFGenerator($clf_base_options['clf_header']);
	?>
	<div class="explanation">
	<h3>UBC Common Look and Feel Header</h3>
	<p>The CLF Advanced theme allows you to configure the UBC common look and feel (CLF) visual identity header.
	
	Easily change <strong>colours</strong>, <strong>labels</strong>, and <strong>links</strong>.
	</p>
	<p>Please refer to the <a href="http://cardinals.ubc.ca/clf">CLF brand website</a> for guidelines and requirements in the use of the UBC CLF.</p>
	</div>
	
	<span>Header Preview:</span>
	<div id="clf_header_sample" >
		<img style="width:47px;height:49px" src="<?php echo $clf_header->display_ubclogo_image(); ?>" /><img style="width:94px;height:49px" src="<?php echo $clf_header->display_pom_on_image(); ?>" /><img style="width:190px;height:49px" src="<?php echo $clf_header->display_header_image(); ?>" /><img style="width:157px;height:49px" src="<?php echo $clf_header->display_unit_image(); ?>" />
	</div>

	<?php	
}

function clf_base_theme_options_clf_header_colors()
{	
	
	global $clf_base_options;
	?>
	
	<div class="explanation">
	<h3>Standard CLF Colour Options</h3>
	<p>There are four standard colour options for CLF website headers, all of which use a combination of the UBC blue, gray and white colours.</p>
	</div>
	<div id="clf-header-standard-options" class="clf-header-option">
	<?php
	$num = 1;
	while($num<5):
		clf_base_clf_header_option($num);
		$num++;
	endwhile;
	
	?>
	</div>

	
	<div class="explanation">
	<h3>Custom Colour Options</h3>
	<p>In addition to the four standard colour options, the CLF Advanced Theme also allows custom colours to be added to the 'a place of mind' button when used with a UBC grey or white background.</p>
	</div>
	<div class="half clf-header-option">
	<?php
	while($num<7):
		clf_base_clf_header_option($num);
		$num++;
	endwhile;
	?>
	</div>
	
	
	</div>	
	<div class="half"> 
	<label>Enter a custom color (RGB Hexcode only)</label><br />
	#<input id="hexcode" class="color-picker"size="6" maxlength="6" name="clf_base[clf_header][hexcode]" type="text" value="<?php echo $clf_base_options['clf_header']['hexcode']; ?>"> <br />
	</div>
	<?php 
}

function clf_base_theme_options_clf_header_faculty()
{
	global $clf_base_options;
	
	?><div class="explanation">
	<p>The faculty label is the label in the middle of the header.  Use 'The University of British Columbia' if your unit is not part of a faculty.</p>
	<p><em>i.e. Faculty of Arts, Faculty of Applied Science</em></p>
	</div>

	<div class="half">
		
		<label>Label</label><br />
		<textarea name="clf_base[clf_header][umbrella_name]" class="text"><?php echo $clf_base_options['clf_header']['umbrella_name']; ?></textarea>
		
	</div>
	<div class="half">
		<label>Link to</label>
		<input name="clf_base[clf_header][umbrella_link]" type="text" class="text" value="<?php echo $clf_base_options['clf_header']['umbrella_link']; ?>" />
	</div>
	
	<?php 
}

function clf_base_theme_options_clf_header_unit()
{
	global $clf_base_options;

	?>
	<div class="explanation">
	<p>The unit label is the label on the right side of the header and is used to identify your unit.  When adding your unit, you can use multiple lines of text.  This label defaults to 'UBC Sites' if no specific unit is added.</p>

	<p><em>i.e. Department of Linguistics.</em></p>
	</div>
	<div class="half">
		
		<label>Label</label><br />
		<textarea name="clf_base[clf_header][unit_name]" class="text"><?php echo $clf_base_options['clf_header']['unit_name']; ?></textarea>
		
	</div>
	
	<div class="half">
		<label>Link to</label>
		<input name="clf_base[clf_header][unit_link]" type="text" class="text" value="<?php echo $clf_base_options['clf_header']['unit_link']; ?>" />
	</div>
	<?php 
}


function clf_base_theme_options_clf_location() {
	global $clf_base_options;
	if(!isset($clf_base_options['clf_header']['location']))
		$clf_base_options['clf_header']['location'] = 'vancouver';
		
	?>
	<div class="explanation">
	<p>There are 2 main UBC campus locations. Depending on what campus location you select, the CLF theme will adjust background colour and and links in the footer accordingly. </p>
	</div>
		
	<div class="half">
		<label><input type="radio" name="clf_base[clf_header][location]" value="vancouver" <?php checked($clf_base_options['clf_header']['location'], 'vancouver'); ?> /> Vancouver</label><br />
		<label><input type="radio" name="clf_base[clf_header][location]" value="okanagan" <?php checked($clf_base_options['clf_header']['location'], 'okanagan'); ?> /> Okanagan</label>
	</div>
	<div class="half">
		<strong>Please note</strong>: That you will also have to change the make changes to the fonts and colours section of theme options to implement the colour scheme. 
	</div>
	
	
	<?php 

}

/*
 * Helper Function
 */
function clf_base_clf_header_option($num)
{
	global $clf_base_options;
	
	$opt_name = array(
		1 => 'Solid Blue',
		2 => 'Blue on White',
		3 => 'Solid Grey',
		4 => 'Grey on White',
		5 => 'Custom colour on Grey',
		6 => 'Custom colour on White',
	);
	
	?>
		<div class="option option-half">
			<img id="option<?php echo $num; ?>_img" src="<?php echo get_bloginfo('stylesheet_directory');?>/library/clf-header/panel-img/option<?php echo $num; ?>.png" />
			<label><input type="radio" value="<?php echo $num; ?>" name="clf_base[clf_header][option]" <?php checked($clf_base_options['clf_header']['option'], $num); ?>> Option <?php echo $num; ?> - <?php echo $opt_name[$num]; ?></label>
			
		</div>
	<?php
}


/** 
 * GENERATE THE CLF HEADER 
 **************************************************************************************************/
function clf_base_clf_header_generate($input) {

	$clf_header = new ClfBaseCLFGenerator($input['clf_header']);
	
	$clf_header->generate_header_images();
	
	// endif;
	return $input;
}


