/********************************************************************************************
File:           main.js
Version:        6.0
Last Modified:  Aug-25-2009
---------------------------------------------------------------------------------------------
Description:    Javascript functions for the University of British Columbia's web sites.
---------------------------------------------------------------------------------------------
Notes:          Main Javascript functions mega menus, spotlight rotation and widgets.
---------------------------------------------------------------------------------------------
Version Notes:
- v.6.0:        Official JS scripts released with Template 6.0.
---------------------------------------------------------------------------------------------
Contact:        UBC Public Affairs
                t: 604.822.2130
                e: web.admin@ubc.ca
                w: www.webcommunications.ubc.ca

********************************************************************************************/
		// var UbcMegaMenu = true;
		
		// Turns Place of Mind Effect on or off - See $(document).ready() & Ubc.megaMenu.init() in main.js
		// var UbcPlaceOfMind = false;
		
		// Turns MainMenu drop-downs on or off - See $(document).ready() & Ubc.megaMenu.init() in main.js
		// var UbcMainMenuDropDown = false;
		
		// Appends URL string after http://www.aplaceofmind.ubc.ca/ in the Learn More button in the Place of Mind MegaMenu. 
		// Use an emptry string - i.e. "" - for the link to go directly to http://www.aplaceofmind.ubc.ca/
		// var UbcPlaceOfMindLink = "";
		
		// Sets the RSS feed address for the A Place of Mind effect -  See method Ubc.placeOfMind.loadRss() in main.js
		// var UbcPlaceOfMindRSS = "";
		
		
		
		// Set Search Label - If in doubt, use your unit's name.  i.e. Human Resources, Arts, President's Office, etc.
		// See Ubc.search.init() in main.js
		// var SubUnitLabel = "Office of Learning Technology";
		
		// Set Search Domain - Specify the domain for search results.  If in doubt, use *.yourdomain.ubc.ca - i.e. *.hr.ubc.ca, *.arts.ubc.ca, *.president.ubc.ca
		// See Ubc.search.init() in main.js
		// var SearchSite = "CTLT.ubc.ca";
/* NOTE 
to minify the javascript use http://www.minifyjs.com/javascript-compressor/
*/
(function($) {
    
	//Load Google feed js
	 google.load("feeds", "1");
		
	$(document).ready(function() 
    {
    	
    	if(clfBaseCwl.UbcMegaMenu) { // See Config Settings in config.js
			Ubc.megaMenu.init();
		}
		
    	// Ubc.search.init(); uncomented by Enej CTLT
    	Ubc.homeQuickLinks.init();
    	Ubc.homeHeadlineWidget.init();
		
		if(clfBaseCwl.UbcPlaceOfMind && clfBaseCwl.UbcMegaMenu) { // See Config Settings in config.js
    		Ubc.placeOfMind.init();
		}
    });

    var Ubc = window.Ubc || {};
    
    Ubc.megaMenu = {
        currentMegaMenu: null,
        links: null,
        isAnimating: false,
		

        init: function() 
        {
			if(clfBaseCwl.UbcPlaceOfMind) { // See Config Settings in config.js
				Ubc.megaMenu.links = $('#UbcCampusLinks, #UbcDirectLinks, #UbcQuickLinks, #UbcMindLink').click(Ubc.megaMenu.onMegaClick);
			} else {
				Ubc.megaMenu.links = $('#UbcCampusLinks, #UbcDirectLinks, #UbcQuickLinks').click(Ubc.megaMenu.onMegaClick);
			}
			
            $('#UbcMegaMenues a.UbcCloseBtn').click(Ubc.megaMenu.onCloseBtnClick);
        },

        onMegaClick: function(event) 
        {
            event.preventDefault();
			
			if($('.UbcCampusLinks').length<1) { // If Megamenu hasn't been remotely loaded yet.
				$.getJSON("http://da.ubc.ca/visualidentity/clf/header/globalutility.php?jsoncallback=?", function(data, textStatus) {
					$('#UbcMegaMenues a.UbcCloseBtn').before(data.html); // Load it, and then place it in the div
				});

				// Set callback to trigger the "click" action on the link when AJAX is done getting the MegaMenu
				$(this).ajaxStop(function(){
					$(this).click();
					$(this).unbind('ajaxStop');
				});

				return; // prevents the animation part of the script from running. Re-trigger the action through the ajaxStop binding above.
			}

            if (Ubc.megaMenu.isAnimating) return;

            var anchor = $(this);
            var id = anchor.attr('id');

            if (Ubc.megaMenu.currentMegaMenu && anchor.attr('id') != Ubc.megaMenu.currentMegaMenu) 
            {
                $('#UbcMegaMenues ul.' + Ubc.megaMenu.currentMegaMenu).hide();
                Ubc.megaMenu.links.removeClass('UbcSelected').trigger('closed');
                Ubc.megaMenu.currentMegaMenu = null;
            }

            var megaMenuSelector = '#UbcMegaMenues ul.' + id;

            Ubc.megaMenu.isAnimating = true;

            if (anchor.hasClass('UbcSelected')) 
            {
                //hide menu
                $(megaMenuSelector).slideUp(400, function() { 
                anchor.removeClass('UbcSelected').trigger('closed'); // Added By Enej CTLT 
                $('#UbcMegaMenues').slideUp(200, Ubc.megaMenu.onAnimationFinish); });

                // anchor.removeClass('UbcSelected').trigger('closed'); Removed by Enej CTLT
                Ubc.megaMenu.currentMegaMenu = null;
            }
            else 
            { //show menu
                $(megaMenuSelector).show();
                $('#UbcMegaMenues').slideDown(400, Ubc.megaMenu.onAnimationFinish);
                anchor.addClass('UbcSelected').trigger('opened');
                Ubc.megaMenu.currentMegaMenu = id;
            }
        },

        onCloseBtnClick: function(event) 
        {
            event.preventDefault();

            if (Ubc.megaMenu.isAnimating) return;

            Ubc.megaMenu.isAnimating = true;

            $('#UbcMegaMenues').slideUp(400, function() 
            {
                $('#UbcMegaMenues ul.' + Ubc.megaMenu.currentMegaMenu).hide();
                Ubc.megaMenu.onAnimationFinish();
            });
            Ubc.megaMenu.links.removeClass('UbcSelected').trigger('closed');
        },

        onAnimationFinish: function() 
        {
        	Ubc.megaMenu.isAnimating = false;
        }
    };

    
    Ubc.homeQuickLinks = {
        init: function() 
        {
            var items = $('#UbcContentSidebar div.UbcQuickLinks ul.UbcLinksBar li a').click(Ubc.homeQuickLinks.onClick);

            var selected = $('#UbcContentSidebar div.UbcQuickLinks ul.UbcLinksBar li.UbcSelected a').click();

            if (selected.length == 0) 
            {
                $(items.get(0)).parent('li').addClass('UbcSelected');
                $(items.get(0)).click();
            }
        },

        onClick: function(event) {
            var lis = $('#UbcContentSidebar div.UbcQuickLinks ul.UbcLinksBar li').removeClass('UbcSelected');

            $(this).parent('li').addClass('UbcSelected');

            var count = 0;
            lis.each(function(i) 
            {
                if ($(this).hasClass('UbcSelected')) 
                {
                    count = i;
                    return false;
                }
            });

            var sections = $('#UbcContentSidebar div.UbcQuickLinks ul.UbcLinksSection').hide();

            if (sections.length >= count)
                $(sections.get(count)).show();

            event.preventDefault();
        }
    };

    Ubc.homeHeadlineWidget = {
        listing: null,

        init: function() 
        {
    		Ubc.homeHeadlineWidget.listing = $('#UBCHeadlineWidget ul.UBCStoriesListing');

            if (Ubc.homeHeadlineWidget.listing.length == 0) return;

            var listingLength = Ubc.homeHeadlineWidget.listing.children('li').length;
            $('#UBCHeadlineWidget div.UbcHeadlineNav span').text('1 / ' + listingLength.toString());

            Ubc.homeHeadlineWidget.listing.cycle({
                fx: 'fade',
                timeout: 5000,
                speed: 600,
                next: '#UBCHeadlineWidget div.UbcHeadlineNav a.UbcHeadlineNavNext',
                prev: '#UBCHeadlineWidget div.UbcHeadlineNav a.UbcHeadlineNavPrev',
                after: Ubc.homeHeadlineWidget.onStoryTransition
            });

            $('#UBCHeadlineWidget div.UbcHeadlineNav a.UbcHeadlineNavPause').click(Ubc.homeHeadlineWidget.onPause);
        },

        onPause: function(event) 
        {
            var btn = $(this);

            if (btn.hasClass('UbcHeadlineNavPause')) 
            {
                btn.removeClass('UbcHeadlineNavPause');
                btn.addClass('UbcHeadlineNavPlay');
                Ubc.homeHeadlineWidget.listing.cycle('pause');
            }
            else 
            {
            	btn.removeClass('UbcHeadlineNavPlay');
            	btn.addClass('UbcHeadlineNavPause');
            	Ubc.homeHeadlineWidget.listing.cycle('resume');
            }

            event.preventDefault();
        },

        onStoryTransition: function(currSlideElement, nextSlideElement, options, forwardFlag) 
        {
            $('#UBCHeadlineWidget div.UbcHeadlineNav span').text((options.currSlide + 1).toString() + ' / ' + Ubc.homeHeadlineWidget.listing.children('li').length.toString());
        }
    };

    Ubc.placeOfMind = {
        state: true,
        loaded: false,
        month: ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'],
        init: function() 
        {
		    var pomEle = $('<ul class="UbcMegaMenu UbcCol4 UbcMindLink UbcClear"></ul>');
		    pomEle.append('<li class="UbcPMCallout"><h2>A place of mind; UBC is tackling the world\'s big problems. With you.</h2><a href="http://www.aplaceofmind.ubc.ca/'+clfBaseCwl['UbcPlaceOfMindLink']+'">Learn more</a></li>');
		    pomEle.append('<li class="UbcLoading"><img style="padding: 50px 100px;" src="/wp-content/themes/clf-base/library/clf/img/header/circularLoading.gif" alt="loading" /></li>');
    		
		    $('#UbcMegaMenues').prepend(pomEle);
		    
			$('a#UbcMindLink').addClass('clf-base-pomOn');
			
		    $('a#UbcMindLink').mouseenter(function() 
            {
                if (Ubc.placeOfMind.state) 
                {
                    Ubc.placeOfMind.state = false;
                    $(this).addClass('clf-base-pomOff').removeClass('clf-base-pomOn');
                }
                else 
                {
                    Ubc.placeOfMind.state = true;
                    $(this).addClass('clf-base-pomOn').removeClass('clf-base-pomOff');
                }
            });

            $('a#UbcMindLink')
                .bind('opened', function(event) 
                {
                    $(this).parent('li.UbcMindLink').css('background-position', '0 -98px');
                    
                    //Change BG
                    $('#UbcMegaMenuesWrapper, #UbcMegaMenues').addClass('UbcMindLink');
                    
                    if (!Ubc.placeOfMind.loaded)
                    	Ubc.placeOfMind.loadRss();
                })
                .bind('closed', function(event) 
                {
                    $(this).parent('li.UbcMindLink').css('background-position', '0 0');
                    $('#UbcMegaMenuesWrapper, #UbcMegaMenues').removeClass('UbcMindLink');
                });
        },
        
        loadRss: function()
        {
        	//var feed = new google.feeds.Feed("http://feeds.gawker.com/gizmodo/excerpts.xml"); // fjord's original
			var feed = new google.feeds.Feed(clfBaseCwl['UbcPlaceOfMindRSS']); // See Config Settings in config.js
			
        	feed.setNumEntries(3);
        	
        	feed.load(function(result)
        	{
        		if (result.error)
        		{
        			$('#UbcMegaMenues ul.UbcMindLink li.UbcLoading').html('<p>' + result.error.message + '</p>');
        			return;
        		}
        		
        		Ubc.placeOfMind.loaded = true;
        		
        		$('#UbcMegaMenues ul.UbcMindLink li.UbcLoading').remove();
        		var megaUl = $('#UbcMegaMenues ul.UbcMindLink');
        		
        		for (var i = 0; i < result.feed.entries.length; i++) 
        		{
        			var entry = result.feed.entries[i];
        			var h3 = '<h3><a href="' + entry.link + '" target="_blank">' + entry.title + '</a></h3>';
        			var pubDate = new Date(entry.publishedDate);
        			var date = '<p class="UbcDate">Submitted: ' + Ubc.placeOfMind.month[pubDate.getMonth()] + ' ' + pubDate.getDate().toString() + ', ' + pubDate.getFullYear().toString() + '</p>';
        			var desc = '<p>' + entry.content + '</p>';
        			var more = '<a href="' + entry.link + '" target="_blank" class="UbcMore">More \u00BB</a>';
        			var li = $('<li class="UbcMenuSection">' + h3 + date + desc + more + '</li>');
        			
        			megaUl.append(li);
        		}
        		
        		var colHeight = 0;
        		
        		megaUl.children().each(function(index)
        		{
        			var height = $(this).height();
        			
        			if (height > colHeight)
        				colHeight = height;
        		});
        		
        		//Apply height so all the borders are even
        		megaUl.children().each(function(index)
        		{
        			var ele = $(this);
        			
        			if (ele.hasClass('UbcPMCallout')) return;
        			
        			ele.css('height', colHeight.toString() + 'px');
        		});
        	});
        }
    };
})(jQuery);