<?php 

if( class_exists( 'Custom_CSS_Meta_Box' ) && isset( $clf_base_options['custom_fields']['custom_css'] ) )
	unset( $clf_base_options['custom_fields']['custom_css'] );

if( class_exists( 'Custom_JavaScript_Meta_Box' ) && isset( $clf_base_options['custom_fields']['custom_javascript'] ) ):
	unset( $clf_base_options['custom_fields']['custom_javascript'] );
endif;
	
if( !class_exists( 'Custom_JavaScript_Meta_Box' ) ):
	add_action( "hybrid_after_html" , 'clf_base_custom_fields_custom_javascript' );
endif;



function clf_base_custom_fields_custom_javascript()
{
	
	global $post, $clf_base_options;
	if( !isset( $clf_base_options['custom_fields']['custom_javascript'] ) )
		return;
	
	if(is_single() || is_page())
	$custom_fields = get_post_custom_values('_custom_js', $post->ID);
	
	if(isset($custom_fields)):
		foreach($custom_fields as  $custom_field):
			echo '<script type="text/javascript">';
			echo $custom_field;
			echo '</script>
';
		endforeach;
	endif;
	
}

 
if( isset($clf_base_options['custom_fields']['custom_javascript']) && isset($clf_base_options['custom_fields']['custom_css'])):
	/* Use the admin_menu action to define the custom boxes */
	add_action('admin_menu', 'clf_base_custom_fields_custom_js_and_css_box');
	
	/* Use the save_post action to do something with the data entered */
	add_action('save_post', 'clf_base_custom_fields_custom_javascript_box_save');
	
	/* Use the save_post action to do something with the data entered */
	add_action('save_post', 'clf_base_custom_fields_custom_css_box_save');
	
	add_action( 'admin_print_styles-post-new.php', 'clf_base_custom_fields_custom_add_css_script_and_style');
	add_action( 'admin_print_styles-post-new.php', 'clf_base_custom_fields_custom_add_javascript_script_and_style');
	add_action( 'admin_print_styles-post.php',		'clf_base_custom_fields_custom_add_css_script_and_style');
	
	
	add_action( 'admin_print_styles-post.php',		'clf_base_custom_fields_custom_add_javascript_script_and_style');

elseif( isset($clf_base_options['custom_fields']['custom_javascript']) ):
	/* Use the admin_menu action to define the custom boxes */
	add_action('admin_menu', 'clf_base_custom_fields_custom_javascript_box');
	
	/* Use the save_post action to do something with the data entered */
	add_action('save_post', 'clf_base_custom_fields_custom_javascript_box_save');
	
	add_action( 'admin_print_styles-post-new.php', 'clf_base_custom_fields_custom_add_javascript_script_and_style');
	add_action( 'admin_print_styles-post.php','clf_base_custom_fields_custom_add_javascript_script_and_style');
endif;

/**
 * clf_base_custom_fields_custom_js_and_css_box function.
 * 
 * @access public
 * @return void
 * Adds a custom section to the "advanced" Post and Page edit screens */
function clf_base_custom_fields_custom_js_and_css_box(){
	add_meta_box( 'clf_base_custom_fields_custom_js_and_css_box_inner', __( 'Custom Javascript', 'clf_base' ), 'clf_base_custom_fields_custom_js_and_css_box_inner', 'post', 'advanced','low' );
	
	add_meta_box( 'clf_base_custom_fields_custom_js_and_css_box_inner', __( 'Custom Javascript', 'clf_base' ), 'clf_base_custom_fields_custom_js_and_css_box_inner', 'page', 'advanced','low' );

}


/**
 * clf_base_custom_fields_custom_javascript_box function.
 * 
 * @access public
 * @return void
 * Adds a custom section to the "advanced" Post and Page edit screens */
function clf_base_custom_fields_custom_javascript_box() {
	add_meta_box( 'clf_base_custom_fields_custom_javascript_box', __( 'Custom Javascript', 'clf_base' ), 'clf_base_custom_fields_custom_javascript_box_inner', 'post', 'advanced','low' );
	add_meta_box( 'clf_base_custom_fields_custom_javascript_box', __( 'Custom Javascript', 'clf_base' ), 'clf_base_custom_fields_custom_javascript_box_inner', 'page', 'advanced','low' );
}
/**
 * clf_base_custom_fields_custom_add_javascript_script_and_style function.
 * 
 * @access public
 * @return void
 */
function clf_base_custom_fields_custom_add_javascript_script_and_style(){
	
	global $post;
	
	if( in_array($post->post_type, array('post','page') ) ):
	
		wp_enqueue_script('clf-base-custom-script-style', get_bloginfo('stylesheet_directory').'/library/custom-fields/codemirror/codemirror.js', array('jquery','jquery-ui-tabs'));
		
		wp_enqueue_script('clf-base-custom-script-javascript', get_bloginfo('stylesheet_directory').'/library/custom-fields/codemirror/javascript.js', 			array('clf-base-custom-script-style'));
		
		wp_enqueue_style('clf-base-custom-script-style', get_bloginfo('stylesheet_directory').'/library/custom-fields/codemirror/codemirror.css');
    endif;
}



/**
 * clf_base_custom_fields_custom_js_and_css_box_inner function.
 * 
 * @access public
 * @return void
 */
function clf_base_custom_fields_custom_js_and_css_box_inner()
{
   global $post;
  
   $clf_base_permission_a = get_post_meta($post->ID, '_custom_js');
   $clf_base_permission =  $clf_base_permission_a[0];
   

   // Use nonce for verification
   echo '<input type="hidden" name="clf_base_custom_fields_custom_javascript_noncename" id="clf_base_permissions_noncename" value="' . wp_create_nonce( 'clf-base-custom-javascript' ) . '" />';
	

   // The actual fields for data entry
  ?><div class="categorydiv" id="custom-css-js" >
		<ul class="category-tabs hide-if-no-js">
			<li ><a href="#custom-css">Custom CSS</a></li>
			<li ><a  href="#custom-js">Custom Javascript</a></li>
		</ul>

		<div class="tabs-panel" id="custom-css">
			<?php clf_base_custom_fields_custom_css_box_inner(); ?>
		</div>
		<div class="tabs-panel" id="custom-js">
			<?php clf_base_custom_fields_custom_javascript_box_inner(); ?>
		</div>
	</div>
	<script type="text/javascript">
	jQuery(document).ready(function(){
		jQuery('#custom-css-js').tabs();});
	</script>
  <?php

}
/**
 * clf_base_custom_fields_custom_javascript_box_inner function.
 * 
 * @access public
 * @return void
 */
function clf_base_custom_fields_custom_javascript_box_inner()
{
   global $post;
  
   $clf_base_permission_a = get_post_meta($post->ID, '_custom_js');
   $clf_base_permission =  $clf_base_permission_a[0];

   // Use nonce for verification
   echo '<input type="hidden" name="clf_base_custom_fields_custom_javascript_noncename" id="clf_base_permissions_noncename_custom_javascript" value="' . wp_create_nonce( 'clf-base-custom-javascript' ) . '" />';
	
   // The actual fields for data entry
  ?>
  	<pre><code> &lt;script type="text/javascript" &gt;</code></pre>
  	<textarea name="clf_base_custom_javascript"  id="clf-base-custom-javascript"><?php echo $clf_base_permission; ?></textarea>
  	<pre><code> &lt;/script&gt;</code></pre> The Javascript code will be inserted at the bottom of the HTML
  	
  <?php

}

/**
 * clf_base_custom_fields_custom_javascript_box_save function.
 * 
 * @access public
 * @param mixed $post_id
 * @return void
 */
function clf_base_custom_fields_custom_javascript_box_save($post_id)
{
	if ( !wp_verify_nonce( $_POST['clf_base_custom_fields_custom_javascript_noncename'], 'clf-base-custom-javascript' )) {
			return $post_id;
	}
	
	// verify if this is an auto save routine. If it is our form has not been submitted, so we dont want
	// to do anything
	if ( defined('DOING_AUTOSAVE') && DOING_AUTOSAVE ) 
	return $post_id;
	
	$data = $_POST['clf_base_custom_javascript'];
	
	// Do something with $mydata 
	// probably using add_post_meta(), update_post_meta(), or 
	// a custom table (see Further Reading section below)
	
	if(get_post_meta($post_id, '_custom_js') == "")  
		add_post_meta($post_id, '_custom_js', $data, true);  
	
	elseif($data != get_post_meta($post_id, '_custom_js', true))  
		update_post_meta($post_id, '_custom_js', $data);
	 
	return $post_id;
}