<?php 
/** 
 * Layout
 *
 */
add_action('admin_init', 'clf_base_custom_fields');





/**
 * clf_base_layout function.
 * 
 * @access public
 * @return void
 */
function clf_base_custom_fields()
{
	add_settings_section('custom-fields', 'Custom Fields', 'clf_base_theme_options_custom_fields', 'clf-base-theme-options');
		
	add_settings_field('clf-base-clf-display-options-custom-javascript', 'Custom Javascript', 'clf_base_theme_options_custom_javascript', 'clf-base-theme-options', 'custom-fields');
	add_settings_field('clf-base-clf-display-options-custom-css', 'Custom CSS', 'clf_base_theme_options_custom_css', 'clf-base-theme-options', 'custom-fields');
	add_settings_field('clf-base-clf-display-options-real-post-author', 'Real Post Author', 'clf_base_theme_options_real_post_author', 'clf-base-theme-options', 'custom-fields');
	add_settings_field('clf-base-clf-display-options-page-permissions', 'Page Permissions', 'clf_base_theme_options_page_permissions', 'clf-base-theme-options', 'custom-fields');
	add_settings_field('clf-base-clf-display-options-post-url-overwrite', 'Post URL overwrite', 'clf_base_theme_options_post_url_overwrite', 'clf-base-theme-options', 'custom-fields');
}



/**
 * clf_base_theme_options_layout function.
 * 
 * @access public
 * @return void
 */
function clf_base_theme_options_custom_fields() {}



/**
 * clf_base_theme_options_custom_javascript function.
 * 
 * @access public
 * @return void
 */
function clf_base_theme_options_custom_javascript() {
	global $clf_base_options;
	
	$custom_field_js_already_enabled = class_exists( 'Custom_JavaScript_Meta_Box' );
	
	?>
	<div>
		<div class="explanation">
		<?php if( $custom_field_js_already_enabled ): ?>
			It appears that you have the <strong>Custom JavaScript Meta Box</strong> Plugin enabled. <br />
			This functionality is already available to you.
		<?php else: ?>
		<h3><label><input type="checkbox"  name="clf_base[custom_fields][custom_javascript]" value="1" <?php checked( isset($clf_base_options['custom_fields']['custom_javascript']) ); ?> /> Enable Custom Javascript</label></h3>
		<?php endif; ?>
		<p>Enable the abiliy to place custom javascript on individual pages and posts. Once enabled a custom text box will apear on page and post write panels and the custom javascript will be written in the footer of the HTML document.</p>
		</div>
		
	</div>
	<?php
}

/**
 * clf_base_theme_options_custom_css function.
 * 
 * @access public
 * @return void
 */
function clf_base_theme_options_custom_css() {
	global $clf_base_options;
	
	$custom_field_css_already_enabled = class_exists( 'Custom_CSS_Meta_Box' );

	?>
	<div>
		<div class="explanation">
		<?php if( $custom_field_css_already_enabled ): ?>
			It appears that you have the <strong>Custom CSS Meta Box</strong> Plugin enabled. <br />
			This functionality is already available to you.
		<?php else: ?>
		<h3><label><input type="checkbox"  name="clf_base[custom_fields][custom_css]" value="1" <?php checked( isset($clf_base_options['custom_fields']['custom_css']) ); ?> /> Enable Custom CSS</label></h3>
		<?php endif; ?>
		<p>Enable the abiliy to place custom CSS on individual pages and posts. Once enabled a custom text box will apear on page and post write panels and the custom CSS will be written in the Head of the HTML document.</p>
		</div>
	</div>
	<?php
}

/**
 * clf_base_theme_options_real_post_author function.
 * 
 * @access public
 * @return void
 */
function clf_base_theme_options_real_post_author() {
	global $clf_base_options;
	
	$custom_field_author_already_enabled = class_exists( 'Real_Post_Author_Meta_Box' );
	
	?>
	<div>
		<div class="explanation">
		<?php if( $custom_field_author_already_enabled ): ?>
			It appears that you have the <strong>Real Post Author Meta Box</strong> Plugin enabled. <br />
			This functionality is already available to you.
		<?php else: ?>
		
		<h3><label><input type="checkbox"  name="clf_base[custom_fields][real_post_author]" value="1" <?php checked( isset($clf_base_options['custom_fields']['real_post_author']) ); ?> /> Enable Real Post Author</label></h3>
		<?php endif; ?>
		<p>Enable the ability to credit the real author of a post or page without having the author be a member of this blog.</p>
		</div>
	</div>
	<?php
}

/**
 * clf_base_theme_options_page_permissions function.
 * 
 * @access public
 * @return void
 */
function clf_base_theme_options_page_permissions() {
	global $clf_base_options;
	?>
	<div>
		<div class="explanation">
		<h3><label><input type="checkbox"  name="clf_base[custom_fields][page_permissions]" value="1" <?php checked( isset($clf_base_options['custom_fields']['page_permissions']) ); ?> /> Enable Page Permissions</label></h3>
		<p>Enable page permissions will allow you to display content only to a more targeted audience, based on their user level.</p>
		</div>
		
	</div>
	<?php
}
/**
 * clf_base_theme_options_post_url_overwrite function.
 * 
 * @access public
 * @return void
 */
function clf_base_theme_options_post_url_overwrite() {
	global $clf_base_options;
	?>
	<div>
		<div class="explanation">
		<h3><label><input type="checkbox"  name="clf_base[custom_fields][post_url_overwrite]" value="1" <?php checked( isset($clf_base_options['custom_fields']['post_url_overwrite']) ); ?> /> Enable Post and Page URL Overwrite</label></h3>
		<p>Enable the ability to redirect pages and posts to a different url once their url displayed.</p>
		</div>
		
	</div>
	<?php
}








