<?php


/* This file contains helper function that are used by both preview.php and panel */


/**
 * clf_base_add_google_fonts function.
 * 
 * @access public
 * @param mixed $body
 * @param mixed $heading
 * @return void
 */
function clf_base_add_google_fonts( $body, $heading ) {
	global $clf_base_options;
	$body_font = explode(",",$body);
	
	$body_heading = explode(",",$heading);
	
	$import = null;
	if(	clf_base_is_google_font( $body_font[0] ) ):
		
		if( clf_base_is_google_fonts_bold( $body_font[0] ) && isset( $clf_base_options['fonts-and-colors']['fonts']['include-bold'] ) ):
			$import = "@import url(http://fonts.googleapis.com/css?family=".str_replace(" ","+",$body_font[0]).":400,700";
		else:
			$import = "@import url(http://fonts.googleapis.com/css?family=".str_replace(" ","+",$body_font[0]);
		endif;
		
	endif;
	
	// no need to try to request the same font twice
	if( $body_heading != $body_font ):
	
		if( clf_base_is_google_font( $body_heading[0] ) ):
		
			if( $import ):
				
				if( clf_base_is_google_fonts_bold( $body_heading[0] ) && isset( $clf_base_options['fonts-and-colors']['fonts']['include-bold'] ) ):
					$import.="|".str_replace(" ","+",$body_heading[0]).":400,700";
				else:
					$import.="|".str_replace(" ","+",$body_heading[0]);
				endif;

			else:
				
				if( clf_base_is_google_fonts_bold( $body_heading[0] ) && isset( $clf_base_options['fonts-and-colors']['fonts']['include-bold'] ) ):
					$import = "@import url(http://fonts.googleapis.com/css?family=".str_replace(" ","+",$body_font[0]).":400,700";
				else:
					$import = "@import url(http://fonts.googleapis.com/css?family=".str_replace(" ","+",$body_font[0]);
				endif;
				
			endif;
			
		endif;
		
	endif; 
	if($import):
		$import.="); /* import google fonts */ \n" ;
		return $import;
	endif;
	
	return null;
	
}
/**
 * clf_base_supported_google_fonts function.
 * Array of supported Google Fonts 
 * @access public
 * @return void
 */
function clf_base_supported_google_fonts() {
	return array(
			'Abel',
			'Abril',
			'Amaranth',
			'Allerta',
			'Arimo',
			'Arvo',
			'Cabin',
			'Cuprum',
			'Belgrano',
			'Bentham',
			'Bevan',
			'Bigshot One',
			'Cantarell',
			'Cardo',
			'Didact Gothic',
			'Dosis',
			'Francois One',
			'Gentium Basic',
			'Gravitas One',
			'Lato',
			'Mako',
			'Merriweather',
			'Old Standard TT',
			'Open Sans',
			'Oswald',
			'Pacifico',
			'Philosopher',
			'PT Sans Caption',
			'PT Sans Narrow',
			'Quattrocento',
			'Quattrocento Sans',
			'Puritan',
			'Vollkorn'
	);
}

function clf_base_is_google_fonts_bold() {
	return array(
			'Amaranth',
			'Arimo',
			'Arvo',
			'Cabin',
			'Cuprum',
			'Cantarell',
			'Cardo',
			'Dosis',
			'Gentium Basic',
			'Gravitas One',
			'Lato',
			'Merriweather',
			'Old Standard TT',
			'Open Sans',
			'Oswald',
			'Philosopher',
			'PT Sans Caption',
			'PT Sans Narrow',
			'Quattrocento',
			'Quattrocento Sans',
			'Puritan',
			'Vollkorn'
	);
}
/**
 * clf_base_is_google_font function.
 * I can tell you if you are a google font or not
 * @access public
 * @param mixed $font
 * @return bool
 */
function clf_base_is_google_font($font)
{
	$single_font = explode(",",$font);
	if( in_array( $single_font[0], clf_base_supported_google_fonts() ) ) return true;
	
	return false;
}