<?php
/** 
 * Frontpage
 * 
 * Lets the user choose what layout grid they want to use and enables that with css
 */

global $clf_base_load_backend;
if($clf_base_load_backend)
	require_once("panel.php");

require_once("spotlight/spotlight.php");

add_action('init','clf_base_frontpage_init');
add_filter('template_redirect','clf_base_frontpage_template');

// register the frontpage widget
register_sidebar( 
	array( 'name' => __('Frontpage', 'hybrid'), 
	'id' => 'frontpage-widget', 
	'before_widget' => '<div id="%1$s" class="widget %2$s widget-%2$s"><div class="widget-inside">', 
	'after_widget' => '</div></div>', 
	'before_title' => '<h3 class="widget-title">', 
	'after_title' => '</h3>' ) );
	
/**
 * clf_base_frontpage_init function.
 * 
 * @access public
 * @return void
 */
function clf_base_frontpage_init()
{
	global $clf_base_options;
	
	if($clf_base_options['frontpage']['option']>=1):
		add_filter( 'sidebars_widgets', 'clf_base_frontpage_remove_sidebars' );
	endif;
		
	/*
	if(!is_admin()):
		wp_register_style('clf-base-frontpage-layout', get_bloginfo('stylesheet_directory').'/library/frontpage/css/layout.css');
		wp_enqueue_style('clf-base-frontpage-layout');

	endif;
	*/
	
	add_filter('hybrid_body_class', 'clf_base_frontpage_body_class');
	
}

/**
 * clf_base_frontpage_remove_sidebars function.
 * 
 * @access public
 * @param mixed $sidebars_widgets
 * @return void
 */
function clf_base_frontpage_remove_sidebars($sidebars_widgets ) {
	if( is_front_page()  ):
		unset($sidebars_widgets['primary']); 
		unset($sidebars_widgets['secondary']);
		//$sidebars_widgets = array( false );
	endif;
	return $sidebars_widgets;
}

/**
 * clf_base_frontpage_template function.
 * 
 * @access public
 * @param mixed $page_template
 * @return void
 */
function clf_base_frontpage_template($page_template) {
	
	if( is_front_page() ) :
		load_template( STYLESHEETPATH."/home.php" );
		die();
		endif;
	return false;
}

/**
 * clf_base_frontpage_body_class function.
 * 
 * @access public
 * @param mixed $body_class
 * @return void
 */
function clf_base_frontpage_body_class($body_class) {
	global $clf_base_options;
	if( is_front_page() )
		return $body_class. " frontpage-option-".$clf_base_options['frontpage']['option']; 
	else
		return $body_class;
}

