<?php
/** 
 * This file is simular to the add-header.php file /library/images/header/
 */


if (!current_user_can('upload_files'))
	wp_die(__('You do not have permission to upload files.')); 

require_once(ABSPATH . '/wp-admin/custom-header.php');

define('MOBILE_ICON_WIDTH_FULL', 144);
define('MOBILE_ICON_HEIGHT_FULL', 144);
define('MOBILE_ICON_WIDTH_SMALL', 57);
define('MOBILE_ICON_HEIGHT_SMALL', 57);

/**
 * 
 *
 */
/**
 * CLF_Base_Custom_Image_Header class.
 *  This class is pretty much a rewrite of the class found in custom-header.php 
 * @extends Custom_Image_Header
 */
class CLF_Base_Custom_Mobile_Icon extends Custom_Image_Header
{ 
	/**
	 * init function.
	 * 
	 * @access public
	 * @return void
	 */
	function init() {
		
		$page = "clf-base-add-icons";
		add_action("admin_print_scripts-$page", array(&$this, 'js_includes'));
		add_action("admin_print_styles-$page", array(&$this, 'css_includes'));
		add_action("admin_head-clf-base-add-header", array(&$this, 'take_action'), 50);
		add_action("admin_head-clf-base-add-header", array(&$this, 'js'), 50);
		add_action("admin_head-$page", $this->admin_header_callback, 51);
		
	}
	/**
	 * finished function.
	 * 
	 * @access public
	 * @return void
	 */
	function finished() {
		
		?>
		<script type="">
		self.parent.update_deafult_header('<?php esc_url(header_image()) ?>');
		</script>
		<div class="wrap">
		<h2><?php _e('Icon complete!'); ?></h2>
		
		<p><?php _e('Visit your site and you should see the new header now.'); ?></p>
		<div id="headimg">
		<img src="<?php esc_url(header_image()) ?>" />
		</div>

		<p><a href="#" onclick="self.parent.tb_remove()" class="button">Done</a></p>

		</div>
		<?php
	}
	/**
	 * step_1 function.
	 * 
	 * @access public
	 * @return void
	 */
	function step_1() {
	?>
	<div class="wrap">
		<h2><?php _e('Your Mobile Icon'); ?></h2>
		<p><?php _e('This is your mobile icon. You can upload and crop a new icon.'); ?></p>

		<div id="headimg">
		
		</div>
		
	</div>
	
	<div class="wrap">
		<h2><?php _e('Upload New Mobile Icon'); ?></h2><p><?php _e('Here you can upload a custom mobile icon. On the next screen you will be able to crop the image.'); ?></p>
		<p><?php printf(__('Images of exactly <strong>%1$d x %2$d pixels</strong> will be used as-is.'), MOBILE_ICON_WIDTH_FULL, MOBILE_ICON_HEIGHT_FULL); ?></p>

		<form enctype="multipart/form-data" id="uploadForm" method="POST" action="<?php echo esc_attr(add_query_arg('step', 2)) ?>" style="margin: auto; width: 50%;">
			<label for="upload"><?php _e('Choose an image from your computer:'); ?></label><br /><input type="file" id="upload" name="import" />
			<input type="hidden" name="action" value="save" />
			<?php wp_nonce_field('custom-icon') ?>
		<p class="submit">
		<input type="submit" value="<?php esc_attr_e('Upload'); ?>" />  
		 or <a href="#" onclick="self.parent.tb_remove();" class="button">cancel</a></p>
		</form>
	</div>
	<?php 
	}
	/**
	 * step_2 function.
	 * 
	 * @access public
	 * @return void
	 */
	function step_2() {
		check_admin_referer('custom-icon');
		$overrides = array('test_form' => false);
		$file = wp_handle_upload($_FILES['import'], $overrides);

		if ( isset($file['error']) )
		die( $file['error'] );

		$url = $file['url'];
		$type = $file['type'];
		$file = $file['file'];
		$filename = basename($file);

		// Construct the object array
		$object = array(
		'post_title' => $filename,
		'post_content' => $url,
		'post_mime_type' => $type,
		'guid' => $url);

		// Save the data
		$id = wp_insert_attachment($object, $file);

		list($width, $height, $type, $attr) = getimagesize( $file );

		if ( $width == MOBILE_ICON_WIDTH_FULL && $height == MOBILE_ICON_HEIGHT_FULL ) {
			// Add the meta-data
			wp_update_attachment_metadata( $id, wp_generate_attachment_metadata( $id, $file ) );

			set_theme_mod('header_image', esc_url($url));
			do_action('wp_create_file_in_uploads', $file, $id); // For replication
			return $this->finished();
		} elseif ( $width > MOBILE_ICON_WIDTH_FULL ) {
			$oitar = $width / MOBILE_ICON_WIDTH_FULL;
			$image = wp_crop_image($file, 0, 0, $width, $height, MOBILE_ICON_WIDTH_FULL, $height / $oitar, false, str_replace(basename($file), 'midsize-'.basename($file), $file));
			$image = apply_filters('wp_create_file_in_uploads', $image, $id); // For replication

			$url = str_replace(basename($url), basename($image), $url);
			$width = $width / $oitar;
			$height = $height / $oitar;
		} else {
			$oitar = 1;
		}
		?>
		<div class="wrap">
		<form method="POST" action="<?php echo esc_attr(add_query_arg('step', 3)) ?>">
		
		<h2><?php _e('Choose the part of the image you want to use as your header.'); ?></h2>
		<p class="submit"><input type="submit" value="<?php esc_attr_e('Crop Header'); ?>" /></p>
		<div id="testWrap" style="position: relative">
		<img src="<?php echo $url; ?>" id="upload" width="<?php echo $width; ?>" height="<?php echo $height; ?>" />
		</div>
		
		<p class="submit">
		<input type="hidden" name="x1" id="x1" />
		<input type="hidden" name="y1" id="y1" />
		<input type="hidden" name="x2" id="x2" />
		<input type="hidden" name="y2" id="y2" />
		<input type="hidden" name="width" id="width" />
		<input type="hidden" name="height" id="height" />
		<input type="hidden" name="attachment_id" id="attachment_id" value="<?php echo esc_attr($id); ?>" />
		<input type="hidden" name="oitar" id="oitar" value="<?php echo esc_attr($oitar); ?>" />
		<?php wp_nonce_field('custom-header') ?>
		<input type="submit" value="<?php esc_attr_e('Crop Header'); ?>" />

		</p>
		<p> or <a href="#" onclick="self.parent.tb_remove();" class="button">cancel</a></p>
		
		</form>
		</div>
	<?php
	}
	/**
	 * step_3 function.
	 * 
	 * @access public
	 * @return void
	 */
	function step_3() {
		check_admin_referer('custom-header');
		if ( $_POST['oitar'] > 1 ) {
			$_POST['x1'] = $_POST['x1'] * $_POST['oitar'];
			$_POST['y1'] = $_POST['y1'] * $_POST['oitar'];
			$_POST['width'] = $_POST['width'] * $_POST['oitar'];
			$_POST['height'] = $_POST['height'] * $_POST['oitar'];
		}

		$original = get_attached_file( $_POST['attachment_id'] );

		$cropped = wp_crop_image($_POST['attachment_id'], $_POST['x1'], $_POST['y1'], $_POST['width'], $_POST['height'], HEADER_IMAGE_WIDTH, HEADER_IMAGE_HEIGHT);
		if ( is_wp_error( $cropped ) )
			wp_die( __( 'Image could not be processed.  Please go back and try again.' ), __( 'Image Processing Error' ) );

		$cropped = apply_filters('wp_create_file_in_uploads', $cropped, $_POST['attachment_id']); // For replication

		$parent = get_post($_POST['attachment_id']);
		$parent_url = $parent->guid;
		$url = str_replace(basename($parent_url), basename($cropped), $parent_url);

		// Construct the object array
		$object = array(
			'ID' => $_POST['attachment_id'],
			'post_title' => basename($cropped),
			'post_content' => $url,
			'post_mime_type' => 'image/jpeg',
			'guid' => $url
		);

		// Update the attachment
		wp_insert_attachment($object, $cropped);
		wp_update_attachment_metadata( $_POST['attachment_id'], wp_generate_attachment_metadata( $_POST['attachment_id'], $cropped ) );

		set_theme_mod('header_image', $url);

		// cleanup
		$medium = str_replace(basename($original), 'midsize-'.basename($original), $original);
		@unlink( apply_filters( 'wp_delete_file', $medium ) );
		@unlink( apply_filters( 'wp_delete_file', $original ) );

		return $this->finished();
	}

}



$clf_base_mobile_icon= new CLF_Base_Custom_Mobile_Icon(null);
$clf_base_mobile_icon->init();

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" <?php do_action('admin_xml_ns'); ?> <?php language_attributes(); ?>>
<head>
<meta http-equiv="Content-Type" content="<?php bloginfo('html_type'); ?>; charset=<?php echo get_option('blog_charset'); ?>" />
<title><?php bloginfo('name') ?> &rsaquo; <?php _e('Uploads'); ?> &#8212; <?php _e('WordPress'); ?></title>
<?php
	wp_enqueue_style( 'global' );
	
	wp_enqueue_style( 'wp-admin' );
	wp_enqueue_style( 'colors' );
if ( 0 === strpos( $content_func, 'media' ) )
	wp_enqueue_style( 'media' );
	wp_enqueue_style( 'ie' );
?>
<script type="text/javascript">
//<![CDATA[
addLoadEvent = function(func){if(typeof jQuery!="undefined")jQuery(document).ready(func);else if(typeof wpOnload!='function'){wpOnload=func;}else{var oldonload=wpOnload;wpOnload=function(){oldonload();func();}}};
var userSettings = {'url':'<?php echo SITECOOKIEPATH; ?>','uid':'<?php if ( ! isset($current_user) ) $current_user = wp_get_current_user(); echo $current_user->ID; ?>','time':'<?php echo time(); ?>'};
var ajaxurl = '<?php echo admin_url('admin-ajax.php'); ?>', pagenow = 'media-upload-popup', adminpage = 'media-upload-popup';
//]]>
</script>
<?php
do_action('admin_enqueue_scripts', 'clf-base-add-header');
do_action('admin_print_styles-clf-base-add-header');
do_action('admin_print_styles');
do_action('admin_print_scripts-clf-base-add-header');
do_action('admin_print_scripts');
do_action('admin_head-clf-base-add-header');
do_action('admin_head');

if ( is_string($content_func) )
	do_action( "admin_head_{$content_func}" );
?>
</head>
<body >


<?php
	
	$clf_base_mobile_icon->admin_page();
	do_action('admin_print_footer_scripts');
?>

<script type="text/javascript">if(typeof wpOnload=='function')wpOnload();</script>
</body>
</html> 


