<?php 

/**
 * bm_sc_mshot function
 * Creates a dynamic screenshot of the site specified in the url parameter
 *
 * [browsershot url="http://link-to-website" width="200px"]
 * @access public
 * @param mixed $attributes
 * @param string $content. (default: '')
 * @param string $code. (default: '')
 * @return void
 */
function bm_sc_mshot($attributes, $content = '', $code = '') {

	extract(shortcode_atts(array(
		'url' => '',
		'width' => 250,
	), $attributes));

	$imageUrl = bm_mshot ($url, $width);

	if ($imageUrl == '') {
		return '';
	} else {
		$image = '<img src="' . $imageUrl . '" alt="' . $url . '" width="' . $width . '"/>';
		return '<div class="browsershot mshot"><a href="' . $url . '">' . $image . '</a></div>';
	}

}

function bm_mshot ($url = '', $width = 250) {

	if ($url != '') {
		return 'http://s.wordpress.com/mshots/v1/' . urlencode(clean_url($url)) . '?w=' . $width;
	} else {
		return '';
	}

}

add_shortcode('browsershot', 'bm_sc_mshot');
